// Learn TypeScript:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/typescript.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class NewClass extends cc.Component {

    @property(cc.Label)
    label: cc.Label = null;

    @property
    text: string = 'hello';

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {}

    start () {
        cc.debug.setDisplayStats(false);


        // checkAndSwitchBuffer(vertexCount) {

        //     if (isIOS14Device) {
        //         if (this.vertexOffset + vertexCount > 65535) {
        //             this.uploadData();
        //             this._batcher._flush();
        //         }
        //     } else {
        //         if (this.vertexOffset + vertexCount > 65535) {
        //             this.uploadData();
        //             this._batcher._flush();
        //             this.switchBuffer();
        //         }
        //     }
        // },

        // cc.MeshBuffer.prototype.checkAndSwitchBuffer = function (vertexCount) {
        //     if (this.vertexOffset + vertexCount > 65535) {
        //         this.uploadData();
        //         this._batcher._flush();
        //     }
        // };

        // cc.MeshBuffer.prototype.requestStatic = function (vertexCount, indiceCount) {

        //     this.checkAndSwitchBuffer(vertexCount);
        //     //字节偏移 = 当前字节偏移+顶点数*顶点字节数
        //     let byteOffset = this.byteOffset + vertexCount * this._vertexBytes;
        //     //索引偏移 = 当前索引偏移 + 索引数
        //     let indiceOffset = this.indiceOffset + indiceCount;
        //     //数据的长度
        //     let byteLength = this._vData.byteLength;
        //     //索引数据的长度
        //     let indiceLength = this._iData.length;
        //     //字节偏移>顶点数据的长度   或者   索引偏移>索引数据的长度
        //     if (byteOffset > byteLength || indiceOffset > indiceLength) {
        //         //循环处理：顶点数据的长度<字节偏移 || 索引数据长度<索引偏移
        //         while (byteLength < byteOffset || indiceLength < indiceOffset) {
        //             //顶点数据个数
        //             this._initVDataCount *= 2;
        //             //索引数据个数
        //             this._initIDataCount *= 2;
        //             //顶点数据字节数 = 个数*字节数
        //             byteLength = this._initVDataCount * 4;
        //             //索引数 = 索引个数
        //             indiceLength = this._initIDataCount;
        //         }
        //         //顶点数大于当有buffer长度时
        //         this._reallocBuffer();
        //     }

        //     let offsetInfo = this._offsetInfo;
        //     offsetInfo.vertexOffset = this.vertexOffset;
        //     this.vertexOffset += vertexCount;

        //     offsetInfo.indiceOffset = this.indiceOffset;
        //     this.indiceOffset += indiceCount;

        //     offsetInfo.byteOffset = this.byteOffset;
        //     this.byteOffset = byteOffset;

        //     this._dirty = true;
        // };

        // cc.MeshBuffer.prototype.request = function(vertexCount, indiceCount) {
        //     if (this._batcher._buffer !== this) {
        //         this._batcher._flush();
        //         this._batcher._buffer = this;
        //     }

        //     this.requestStatic(vertexCount, indiceCount);
        //     return this._offsetInfo;
        // };


        // ModelBatcher.prototype._commitComp = function(comp, assembler, cullingMask) {
        //     if (this.material._hash !== comp._material._hash ||
        //         this.cullingMask !== cullingMask) {
        //         this._flush();

        //         this.node = assembler.useModel ? comp.node : this._dummyNode;
        //         this.material = comp._material;
        //         this.cullingMask = cullingMask;
        //     }

        //     assembler.fillBuffers(comp, this);
        // }
    }

    // update (dt) {}

    
    loadRes(){
        let self = this;
        let arrayList = [
            [
                { path: "clothes/15086/15086_clothes_1", index: 3 },
                { path: "face/20001/20001_face", index: 4 }
            ],
       
            [
                { path: "clothes/15086/15086_clothes_1", index: 3 },
                { path: "face/20001/20001_face", index: 4 }

            ],
        ];
        for (let j = 0; j < arrayList.length; j++) {
            const array = arrayList[j];
            
            let bbNode = new cc.Node();
            bbNode.x = -200+j*400;
            bbNode.y = 200;
            self.node.addChild(bbNode);

            for (let i = 0; i < array.length; i++) {
                const element = array[i];
                cc.loader.loadRes(element.path, sp.SkeletonData, (err, asset: sp.SkeletonData) => {
                    let node  = new cc.Node();
               
                    let skeleton = node.addComponent(sp.Skeleton);
                    skeleton.premultipliedAlpha = false;
                    skeleton.skeletonData = asset;
                    bbNode.addChild(node, element.index);
                    
                    skeleton.setAnimation(1,"normal", true);
                    self.node.scale = 0.5;

                });
            }
        }
       
    }
}
